"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.transformer = void 0;
const tslib_1 = require("tslib");
const dateformat_1 = tslib_1.__importDefault(require("dateformat"));
const semver_regex_1 = tslib_1.__importDefault(require("semver-regex"));
const transformer = (commit, cb) => {
    if (typeof commit.gitTags === 'string') {
        commit.version = (commit.gitTags.match((0, semver_regex_1.default)()) || [])[0];
    }
    if (commit.committerDate) {
        commit.committerDate = (0, dateformat_1.default)(commit.committerDate, 'yyyy-mm-dd', true);
    }
    cb(null, commit);
};
exports.transformer = transformer;
